extends Node2D

export var speed = 160
export var standard_speed = 200
var bodys = [] # Array with Mobs or player in front of the Car
export var linear_velocityN = Vector2(0,0)
var speed_timer = 0.5 #timer for brakeing

func _ready():
	add_to_group("mobs") #add Mob to group Mobs so methodes of it can be called from World
	set_process(false) #turn of process so the Mob doesn't move automatically
	set_physics_process(false)#turn of physiks process so the Mob doesn't move automatically
	#get animation names and chose a random animation for the Mob. This only changes the color
	var mob_types = $AnimatedSprite.frames.get_animation_names() 
	$AnimatedSprite.animation = mob_types[randi()%mob_types.size()]

func _call_process(): #called from world through group Mobs 
	#call _network_process with the time step recieved from world
	#work around cause the group call could not pass a variable
	_network_process(self.get_parent().deltaN)
	
## Called every frame. 'delta' is the elapsed time since the previous frame.
#func _process(delta):
#	if len(bodys)<=1:
#		#print("success")
#		speed = standard_speed		
#	if len(bodys)>1:
#
#		#for i in range (len(bodys)):
#		#	if !is_instance_valid(bodys[i]):
#		#		bodys.erase(bodys[i])
#
#		var closest_body = bodys[1]
#		for i in range(1,len(bodys)):
#			if self.global_position.distance_to(closest_body.global_position) > self.global_position.distance_to(bodys[i].global_position):
#				closest_body = bodys[i]
#		#print (closest_body.linear_velocity.length())
#		if $SpeedTimer.time_left == 0:
#			speed = speed + (self.global_position.distance_to(closest_body.global_position)-300)/10
#			$SpeedTimer.start()
#		if self.global_position.distance_to(closest_body.global_position) < 500:
#			#print (self.global_position.distance_to(closest_body.global_position))
#
#			speed = closest_body.linear_velocity.length()
#		#print(speed)
#	self.linear_velocity = Vector2(0,-speed)

func _network_process(delta):
	speed_timer -= delta
	
	#since the own body is the first Body in Bodys this decides if the road in front of the Mob is free or not
	#if its free the Mob will accelerate
	if (len(bodys)<1) and (speed < standard_speed) and (speed_timer <= 0 ):
		speed = speed + 10
		speed_timer = 0.5	
	
	#if there is a Mob or player in front of the Mob the speed will be reduced depending on the distance
	if len(bodys)>=1:
		
		#for i in range (len(bodys)):
		#	if !is_instance_valid(bodys[i]):
		#		bodys.erase(bodys[i])
		
		#find the closest body
		var closest_body = bodys[0]
		for i in range(0,len(bodys)):
			if self.global_position.distance_to(closest_body.global_position) > self.global_position.distance_to(bodys[i].global_position) && self.global_position.distance_to(closest_body.global_position)!=0 :
				closest_body = bodys[i]
				
		#if the closes Body is closer than 600 pixels brake
		if (speed_timer <= 0 ) and (self.global_position.distance_to(closest_body.global_position) < 600):
			speed = speed - (self.global_position.distance_to(closest_body.global_position)-500)/10
			speed_timer = 0.5
		
		#if the closes Body is further away than 600 pixels accelerate
		if (speed_timer <= 0 ) and (self.global_position.distance_to(closest_body.global_position) > 600):
			speed = speed + (self.global_position.distance_to(closest_body.global_position)-500)/30
			speed_timer = 0.5	
			
		#if the closes Body is closer than 400 Pixels adapt the speed to its speed
		if self.global_position.distance_to(closest_body.global_position) < 400:
			speed = closest_body.linear_velocityN.length()
	
	self.linear_velocityN = Vector2(0,-speed)
	self.global_position = self.global_position+delta*self.linear_velocityN

#func _on_VisibilityNotifier2D_screen_exited():
#	queue_free()




func _on_Area2D_body_entered(body):
	
	#if the Area in front of the Mob is entere by a Mob or the Player append it to bodys
	if body.is_class("RigidBody2D") or body.is_class("KinematicBody2D"):
		bodys.append(body)
		
	#if the area in front of the Mob is entered by a wall meanig it left the road delete the Mob
	if body.is_class("TileMap"):
		self.queue_free()
	

func _on_Area2D_body_exited(body):
	#if the Mob or Player left the area in front of the Mob delete it from body
	bodys.erase(body)

