# -*- coding: utf-8 -*-
"""
Created on Tue Jan 12 17:17:49 2021

@author: theob
"""

import asyncio
import Gym_new
import time
import nest_asyncio
import show_image as si

    

async def main():
    image_mode = 'L'
    
    
    env = Gym_new.Gym()
    await env.connect_websocket()
    
    # Resets the enviroment
    observation, reward, done, info = await env.reset(0.01)
    print(observation)
    print(reward)
    print(done)

    total_reward = 0
    while done and total_reward > -80 and reward[1] < 50:
        # Here could be conditions to determine which actions to take
        actions = "accelerate"
        # For example:
        if observation[2][2] < 4: # observation[2][2] is the sensor to the right and 4 is in meters
            actions += "steer_left"

        # Makes 1 step only driving straight
        observation, reward, done, info = await env.step(actions, 0.01)
        print(observation) 
        # Obeservation is an array with the following information: 
        # [speed, steering-angle, [length of all sensors (starting straight and then clockwise around the car)]]
        print(reward)
        print(done)

        total_reward -= reward[1]
        actions = ""
    
    print(total_reward)

    try:
    # Test show Image
        si.show_image(image_mode,info['thumbnail']['width'],info['thumbnail']['height'],info['thumbnail']['image'])
    except Exception as e:
        print("failed showing image: " + str(e))

if __name__ == "__main__":
    nest_asyncio.apply()
    loop = asyncio.get_event_loop()
    loop.run_until_complete(main())
